<template>
  <div class="d-flex justify-content-center container">
    <div class="w-75">
      <form @submit.prevent="!selectedTodo ? addTodo() : updateTodo()">
        <div class="mb-3 mt-5">
          <label for="todo" class="display-5 mb-3">What's your todo?</label>
          <div class="d-flex">
            <input v-model="todo" type="text" class="form-control" id="todo" placeholder="eg. Create todo application">
            <button v-if="!selectedTodo" class="btn btn-primary ms-3"><i class="bi bi-plus-circle-fill"></i></button>
            <button v-else class="btn btn-primary ms-3"><i class="bi bi-pencil-square"></i></button>
          </div>
        </div>
      </form>
      <div @click="selectTodo(row)" v-for="row in todoList" :key="row.id" class="toast show mt-2 w-100">
        <div class="toast-header">
          <strong class="me-auto">{{ row.todo }}</strong>
          <button :class="`btn btn-${row.is_done ? 'success' : 'outline-secondary'} btn-sm`" @click.stop="markAsDone(row)"><i class="bi bi-check-lg"></i></button>
          <button class="btn btn-danger btn-sm ms-1" @click.stop="removeTodo(row)"><i class="bi bi-trash-fill"></i></button>
        </div>
      </div>
    </div>
</div>
</template>

<script setup>

  import { ref } from 'vue';

  /** ------------------------ PROPERTIES FOR THE TO-DO LIST APPLICATION ------------------------ */
  
  // A todo list.
  let todoList = ref([]);
  
  // A new todo to be added.
  let todo = ref(null); 

  // A reference for the selected todo to be updated.
  let selectedTodo = ref(null); 
  /** -------------------- END OF PROPERTIES FOR THE TO-DO LIST ------------------------ */

  /** -------------------- UTILITY FUNCTIONS FOR TO-DO LIST APP ------------------------ */

  /**
   * function validateTodo(new_todo)
   * 
   * @description
   * - A function that validates the @param new_todo if it is existing or not in the list.
   * 
   * @param new_todo : String
   * - A todo to be evaluated.
   * 
   * @returns 
   * - Returns true if the todo is existing, otherwise false.
   */
  const validateTodo = (new_todo) => {

    let index = todoList.value.findIndex((t) => t.todo.toLowerCase() === new_todo.toLowerCase());

    // If the index is not equal to -1, then the todo currently exist at the list.
    if (index !== -1) {
      alert("Todo already exist!");
      return false;
    } else {
      return true;
    }
  }

  /**
   * function selectTodo(row)
   * 
   * @description
   * - A function that selects/sets the todo to be updated.
   * 
   * @param row : Object
   * - A todo to be updated.
   */
  const selectTodo = (row) => {
    selectedTodo.value = row;
    todo.value = row.todo;
  }

  /**
   * function markAsDone(row)
   * 
   * @description
   * - A function that marks the todo as done.
   * 
   * @param row : Object
   * - A todo to be marked as done.
   */
  const markAsDone = (row) => {

    if (confirm(`Are you sure you want to mark ${row.todo} as done?`)) {

      let index = todoList.value.findIndex((t) => t.id === row.id);
      index !== -1 && (todoList.value[index].is_done = true);
    }
  }


  /** -------------------------------- MAIN FUNCTIONS FOR THE TO-DO LIST ------------------------ */

  /**
   * addTodo()
   * 
   * @description
   * - A function that adds a new @todo to the @todoList
   */
  const addTodo = () => {

      // Checks weather the current todo to be added is existing from the list.
      if (validateTodo(todo.value)) {

        /** For simplicity, we generate the id by getting the length of the todo list and incrementing it by one. */
        let id = todoList.value.length;

        todoList.value.push({
          id: ++id,
          todo: todo.value,
          is_done: false
        })
        todo.value = null // Empty the todo
    }
  }

  /**
   * function updateTodo()
   * 
   * @description
   * - A function that updates the selected todo.
   */
  const updateTodo = () => {

    // Checks weather the current todo to be added is existing from the list.
    if (validateTodo(todo.value)) {

      let index = todoList.value.findIndex((t) => t.id === selectedTodo.value.id);

      // If the index is found, then we update the selected todo.
      index !== -1 && (todoList.value[index].todo = todo.value);

      todo.value = selectedTodo.value = null;
    }
  }

  /**
   * function removeTodo()
   * 
   * @description
   * - A function that removes the selected todo from the todo list.
   * 
   * @param row : Object
   * - A selected row or task to be removed.
   */
  const removeTodo = (row) => {

    if (confirm(`Are you sure you want to delete ${row.todo}?`)) {

      let index = todoList.value.findIndex((t) => t.id === row.id);
      index !== -1 && todoList.value.splice(index, 1);
    }
  }

  /** -------------------------------------------- END OF MAIN FUNCTIONS OF TODO LIST -------------------------------- */
</script>

<style>
</style>